/*  $Id: HashVector.java 1035 2010-06-15 13:08:33Z sdevaux $
 *
 * Tabs = 4 chars
 * copyright (C) 2002 Sebastien Devaux
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *              Sebastien Devaux <sebastien.devaux@laposte.net>
 */
package net.eduvax.util;

import java.util.Hashtable;
import java.util.Vector;
/**
 * @version $Id: HashVector.java 1035 2010-06-15 13:08:33Z sdevaux $
 * @author Sebastien Devaux
 */
public class HashVector<K,V> {
	/**
	 *
	 */
	public V get(int i) {
		return _vector.get(i);
	}
    /**
     *
     */
    public V get(K key) {
        return _hashtable.get(key);
    }
    /**
     *
     */
    public void put(K key,V value) {
        _vector.add(value);
        _hashtable.put(key,value);
    }
    /**
     *
     */
    public void remove(K key) {
        V o=_hashtable.get(key);
        if (o!=null) {
            _vector.remove(o);
            _hashtable.remove(key);
        }
    }
	/**
	 *
	 */
	public int size() {
		return _vector.size();
	}
	/**
	 * 
	 */
	public HashVector() {
		_vector=new Vector<V>();
		_hashtable=new Hashtable<K,V>();
	}
	/** inner vector. */
	private Vector<V> _vector;
	/** vector "index" */
	private Hashtable<K,V> _hashtable;
}
